SystemOrganization addCategory: #'DAO-SatelliteUI'!

WAComponent subclass: #CommandsView
	instanceVariableNames: 'commandList controller subsystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!CommandsView class methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/28/2013 17:38'!
newWithCommands: commands andSubsystem: aSubsystem andController: aSatelliteController 
	^ self new initializeWithCommands: commands andSubsystem: aSubsystem andController: aSatelliteController ! !

!CommandsView methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/28/2013 17:44'!
commandRequest: aCommandDefinition 
	
	controller sendCommand: aCommandDefinition toSubsystem: subsystem withData: OrderedCollection new. ! !

!CommandsView methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/28/2013 17:39'!
initializeWithCommands: commands andSubsystem: aSubsystem andController: aSatelliteController 
	super initialize.
	commandList := commands.
	subsystem := aSubsystem.
	controller := aSatelliteController ! !

!CommandsView methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovich 10/28/2013 18:40'!
renderContentOn: html
	|  commandNames form cmd |
	commandNames:= commandList keys.
	
	form := html form.
	form class: 'pure-form-stacked'.
	form with: 
	
[	html space.
	        html text: 'Command: '.
        html select 
            list: commandNames;
           selected: 'Elija comando';
            callback: [ :value |
				cmd := commandList at: value.
			   	
				].
	html break.
	html label: 'Ingrese los valores de los parmetros separados por comas'.
	html textInput
	callback: [ ].
		
	
	html submitButton
	callback: [ self inform: cmd.
		self answer: (self commandRequest: cmd) ];
	value: 'Send'.]! !

WAComponent subclass: #DAOSatelliteControllerLauncher
	instanceVariableNames: 'controller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!DAOSatelliteControllerLauncher class methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/28/2013 16:21'!
newWithController: aSatelliteController

	^self new initializeWithController: aSatelliteController  ! !

!DAOSatelliteControllerLauncher methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/28/2013 16:23'!
initializeWithController: aSatelliteController

	controller := aSatelliteController 
! !

!DAOSatelliteControllerLauncher methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/21/2013 21:39'!
shutDown

	ZnZincServerAdaptor stop 

! !

!DAOSatelliteControllerLauncher methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/28/2013 19:17'!
startApp

	ZnZincServerAdaptor startOn: 8080.
	(WAAdmin register: CommandRequestUI asApplicationAt: 'DAOSatelliteUI')
		addLibrary: PTDeploymentLibrary;
 	      addLibrary: SUDeploymentLibrary.
	! !

WAComponent subclass: #SatelliteControlWebComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

SatelliteControlWebComponent subclass: #CommandRequestUI
	instanceVariableNames: 'satelliteController subsystems subsystemName commandDefinition subsystem data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-SatelliteUI'!

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/30/2013 15:47'!
commandNamesForSubsystem: aSubsystem
	| commands commandNames |
	
	commands := aSubsystem commands.

	commandNames := commands keys.
	
	^ commandNames.! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/30/2013 16:07'!
commandWithName: aCommandName
	^ subsystem commands at: aCommandName.! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/30/2013 00:37'!
initialize

	| radio |

	super initialize.
"	radio := SatelliteControllerRadio connectTo: #[127 0 1 1 ] port: 4445.
	satelliteController := SatelliteController newWith: radio."
	
	subsystems := OrderedCollection new.
	subsystems add: Subsystem thermal.
	subsystems add: Subsystem cdh.
	subsystems add: Subsystem memory.
	subsystems add: Subsystem platform.
	subsystems add: Subsystem power.
	
	! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/30/2013 16:03'!
renderCommandListOn: ajaxHtml
	"Used by Prototype to update the list of commands"
	| commandNames |
	
	commandNames := self commandNamesForSubsystem: self subsystem.
	
	ajaxHtml select
		callback: [ :value | commandDefinition := self commandWithName: value ];
		list: commandNames

! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/30/2013 16:04'!
renderContentOn: html
	| names form subsystemsElementId commandsElementId |

	names := subsystems collect: [:aSubsystem | aSubsystem name ].

	subsystemsElementId := html nextId.	
	commandsElementId := html nextId.

	form := html form.
	form class: 'pure-form-stacked'.
	form with: [
	      html label: 'Subsystem: '.
		html select
			id: subsystemsElementId;
	            list: names;
	            selected:  names first;
			"update the list with ID commandListElementId, executing renderCommandListOn: ajaxHtml "
			onChange: (html scriptaculous updater 
				id: commandsElementId;
				triggerFormElement: subsystemsElementId;
	                  callback: [ :ajaxHtml | self renderCommandListOn: ajaxHtml ]
			);
			"set the subsystem name posted by the form, then the variable subsystem will be used by renderCommandListOn: ajaxHtml to select the available commands for that subystem"			
			callback: [ :value | subsystem := self subsystemWithName: value. ].
	      html label: 'Command: '.
		html div
			id: commandsElementId;
			with: [ self renderCommandListOn: html ].
		html submitButton
			callback: [self sendCommand].
	]
! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/30/2013 19:00'!
sendCommand
	satelliteController sendCommand: commandDefinition toSubsystem: subsystem withData: OrderedCollection new.! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/30/2013 15:43'!
subsystem
	^ subsystem ifNil: [ subsystems first ].! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/30/2013 15:48'!
subsystemWithName: aSubsystemName
	^ subsystems detect: [ :each | each name = aSubsystemName ]! !

!CommandRequestUI methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/27/2013 17:50'!
subsystems
	^subsystems ! !

!SatelliteControlWebComponent methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendez 10/22/2013 21:09'!
updateRoot: anHtmlRoot
	| cssUrl |
	
	super updateRoot: anHtmlRoot.
	
	"cssUrl := 'http://seaside.st/styles/main.css'."
	cssUrl := 'http://yui.yahooapis.com/pure/0.3.0/pure-min.css'.
	
	anHtmlRoot stylesheet url: cssUrl.! !
